<?php
/**
 * Spaces view filter handler. 
 */
class spaces_handler_filter_spaces_current extends views_handler_filter {
  /**
   * Meta query handler which delegates query building to the
   * implementing spaces.
   */
  function query() {
    // drupal_set_message(var_export($this->options, true));
    $space = spaces_get_space();
    if ($space) {
      if (($this->options['value'] == $space->type) || ($this->options['value'] == 'all')) {
        $space->views_filter(TRUE, $this->view->query);
      }
    }
    else if ($this->options['operator'] == 'all') {
      $types = spaces_types();
      foreach ($types as $type => $info) {
        call_user_func(array($info['class'], 'views_filter'), FALSE, $this->view->query);
      }
    }
  }

  /**
   * Provide filter application conditions.
   */
  function operator_options() {
    return array(
      'all' => t('Apply at all times'),
      'active' => t('Apply only in a space'),
    );
  }

  /**
   * Provide options for defining which space type this filter affects.
   */
  function value_form(&$form, &$form_state) {
    $options = array('all' => t('Applies to any space'));
    foreach (spaces_types() as $type => $info) {
      $options[$type] = t('Applies only in a !spacetype', array('!spacetype' => strtolower($info['title'])));
    }  
    $form['value'] = array(
      '#type' => 'select',
      '#title' => t('Space types'),
      '#options' => $options,
      '#default_value' => $this->value,
    );
  }
  
}
