<?php
function _spaces_core_views_list_views() {
  return array(
    'spaces_blog',
    'spaces_blog_comments',
    'spaces_book_current',
  );
}

function _spaces_core_views_spaces_blog() {
$view = new view;
$view->name = 'spaces_blog';
$view->description = 'Spaces: blog';
$view->tag = 'spaces';
$view->view_php = '';
$view->base_table = 'node';
$view->is_cacheable = FALSE;
$view->api_version = 2;
$view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */
$handler = $view->new_display('default', 'Defaults', 'default');
$handler->override_option('sorts', array(
  'created' => array(
    'order' => 'DESC',
    'granularity' => 'second',
    'id' => 'created',
    'table' => 'node',
    'field' => 'created',
    'relationship' => 'none',
  ),
));
$handler->override_option('arguments', array(
  'created_year_month' => array(
    'default_action' => 'ignore',
    'style_plugin' => 'default_summary',
    'style_options' => array(),
    'wildcard' => 'all',
    'wildcard_substitution' => 'All',
    'title' => 'Archive: %1',
    'default_argument_type' => 'fixed',
    'default_argument' => '',
    'validate_type' => 'none',
    'validate_fail' => 'not found',
    'id' => 'created_year_month',
    'table' => 'node',
    'field' => 'created_year_month',
    'relationship' => 'none',
    'default_options_div_prefix' => '',
    'default_argument_user' => 0,
    'default_argument_fixed' => '',
    'default_argument_php' => '',
    'validate_argument_node_type' => array(
      'blog' => 0,
      'book' => 0,
      'page' => 0,
      'portfolio' => 0,
      'quote' => 0,
      'story' => 0,
    ),
    'validate_argument_node_access' => 0,
    'validate_argument_nid_type' => 'nid',
    'validate_argument_vocabulary' => array(
      '12' => 0,
      '13' => 0,
      '8' => 0,
      '1' => 0,
    ),
    'validate_argument_type' => 'tid',
    'validate_argument_php' => '',
  ),
));
$handler->override_option('filters', array(
  'status' => array(
    'operator' => '=',
    'value' => 1,
    'group' => '0',
    'exposed' => FALSE,
    'expose' => array(
      'operator' => FALSE,
      'label' => '',
    ),
    'id' => 'status',
    'table' => 'node',
    'field' => 'status',
    'relationship' => 'none',
  ),
  'type' => array(
    'operator' => 'in',
    'value' => array(
      'blog' => 'blog',
    ),
    'group' => '0',
    'exposed' => FALSE,
    'expose' => array(
      'operator' => FALSE,
      'label' => '',
    ),
    'id' => 'type',
    'table' => 'node',
    'field' => 'type',
    'relationship' => 'none',
  ),
  'current' => array(
    'operator' => 'all',
    'value' => 'all',
    'group' => '0',
    'exposed' => FALSE,
    'expose' => array(
      'operator' => FALSE,
      'label' => '',
    ),
    'id' => 'current',
    'table' => 'spaces',
    'field' => 'current',
    'relationship' => 'none',
  ),
));
$handler->override_option('access', array(
  'type' => 'none',
));
$handler->override_option('title', 'Blog');
$handler->override_option('use_pager', '1');
$handler->override_option('row_plugin', 'node');
$handler = $view->new_display('page', 'Page', 'page_1');
$handler->override_option('path', 'blog');
$handler->override_option('menu', array(
  'type' => 'none',
  'title' => '',
  'weight' => 0,
  'name' => 'navigation',
));
$handler->override_option('tab_options', array(
  'type' => 'none',
  'title' => '',
  'weight' => 0,
));
$handler = $view->new_display('block', 'Block', 'block_1');
$handler->override_option('arguments', array(
  'created_year_month' => array(
    'default_action' => 'summary desc',
    'style_plugin' => 'default_summary',
    'style_options' => array(),
    'wildcard' => 'all',
    'wildcard_substitution' => 'All',
    'title' => '',
    'default_argument_type' => 'fixed',
    'default_argument' => '',
    'validate_type' => 'none',
    'validate_fail' => 'not found',
    'id' => 'created_year_month',
    'table' => 'node',
    'field' => 'created_year_month',
    'relationship' => 'none',
    'default_options_div_prefix' => '',
    'default_argument_user' => 0,
    'default_argument_fixed' => '',
    'default_argument_php' => '',
    'validate_argument_node_type' => array(
      'blog' => 0,
      'book' => 0,
      'page' => 0,
      'portfolio' => 0,
      'quote' => 0,
      'story' => 0,
    ),
    'validate_argument_node_access' => 0,
    'validate_argument_nid_type' => 'nid',
    'validate_argument_vocabulary' => array(
      '12' => 0,
      '13' => 0,
      '8' => 0,
      '1' => 0,
    ),
    'validate_argument_type' => 'tid',
    'validate_argument_php' => '',
    'override' => array(
      'button' => 'Use default',
    ),
  ),
));
$handler->override_option('title', 'Archive');
$handler->override_option('items_per_page', 12);
$handler->override_option('use_pager', '0');
$handler->override_option('block_description', '');
$handler->override_option('block_caching', -1);
$handler = $view->new_display('feed', 'Feed', 'feed_1');
$handler->override_option('style_plugin', 'rss');
$handler->override_option('style_options', array(
  'mission_description' => FALSE,
  'description' => '',
));
$handler->override_option('row_plugin', 'node_rss');
$handler->override_option('row_options', array(
  'item_length' => 'default',
));
$handler->override_option('path', 'blog/feed');
$handler->override_option('menu', array(
  'type' => 'none',
  'title' => '',
  'weight' => 0,
  'name' => 'navigation',
));
$handler->override_option('tab_options', array(
  'type' => 'none',
  'title' => '',
  'weight' => 0,
));
$handler->override_option('displays', array());
// @TODO: This will not work for anything but spaces_site -- we will
// probably need to add something that will allow the RSS feed title
// to be overridden by the space's name.
$handler->override_option('sitename_title', 1);
return $view;
}

function _spaces_core_views_spaces_blog_comments() {
$view = new view;
$view->name = 'spaces_blog_comments';
$view->description = 'Spaces: blog > comments';
$view->tag = 'spaces';
$view->view_php = '';
$view->base_table = 'comments';
$view->is_cacheable = FALSE;
$view->api_version = 2;
$view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */
$handler = $view->new_display('default', 'Defaults', 'default');
$handler->override_option('relationships', array(
  'nid' => array(
    'label' => 'Node',
    'required' => 0,
    'id' => 'nid',
    'table' => 'comments',
    'field' => 'nid',
    'relationship' => 'none',
  ),
));
$handler->override_option('fields', array(
  'comment' => array(
    'label' => '',
    'exclude' => 0,
    'id' => 'comment',
    'table' => 'comments',
    'field' => 'comment',
    'relationship' => 'none',
  ),
  'name' => array(
    'label' => '',
    'link_to_user' => 0,
    'exclude' => 0,
    'id' => 'name',
    'table' => 'comments',
    'field' => 'name',
    'relationship' => 'none',
  ),
  'timestamp' => array(
    'label' => '',
    'date_format' => 'custom',
    'custom_date_format' => 'g:ia M j',
    'exclude' => 0,
    'id' => 'timestamp',
    'table' => 'comments',
    'field' => 'timestamp',
    'relationship' => 'none',
  ),
  'title' => array(
    'label' => '',
    'link_to_node' => 1,
    'exclude' => 0,
    'id' => 'title',
    'table' => 'node',
    'field' => 'title',
    'relationship' => 'nid',
  ),
));
$handler->override_option('sorts', array(
  'timestamp' => array(
    'order' => 'DESC',
    'granularity' => 'day',
    'id' => 'timestamp',
    'table' => 'comments',
    'field' => 'timestamp',
    'relationship' => 'none',
  ),
));
$handler->override_option('filters', array(
  'status' => array(
    'operator' => '=',
    'value' => 0,
    'group' => '0',
    'exposed' => FALSE,
    'expose' => array(
      'operator' => FALSE,
      'label' => '',
    ),
    'id' => 'status',
    'table' => 'comments',
    'field' => 'status',
    'relationship' => 'none',
  ),
));
$handler->override_option('access', array(
  'type' => 'none',
));
$handler->override_option('title', 'Latest comments');
$handler->override_option('items_per_page', 3);
$handler->override_option('style_plugin', 'list');
$handler->override_option('style_options', array(
  'type' => 'ul',
));
$handler = $view->new_display('block', 'Block', 'block_1');
$handler->override_option('block_description', '');
$handler->override_option('block_caching', -1);
return $view;
}

function _spaces_core_views_spaces_book_current() {
$view = new view;
$view->name = 'spaces_book_current';
$view->description = 'Spaces: book: helper view to look up root book pages';
$view->tag = 'spaces';
$view->view_php = '';
$view->base_table = 'node';
$view->is_cacheable = FALSE;
$view->api_version = 2;
$view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */
$handler = $view->new_display('default', 'Defaults', 'default');
$handler->override_option('filters', array(
  'depth' => array(
    'operator' => '=',
    'value' => array(
      'value' => '1',
      'min' => '',
      'max' => '',
    ),
    'group' => '0',
    'exposed' => FALSE,
    'expose' => array(
      'operator' => FALSE,
      'label' => '',
    ),
    'id' => 'depth',
    'table' => 'book_menu_links',
    'field' => 'depth',
    'relationship' => 'none',
  ),
  'status' => array(
    'operator' => '=',
    'value' => 1,
    'group' => '0',
    'exposed' => FALSE,
    'expose' => array(
      'operator' => FALSE,
      'label' => '',
    ),
    'id' => 'status',
    'table' => 'node',
    'field' => 'status',
    'relationship' => 'none',
  ),
  'current' => array(
    'operator' => 'active',
    'value' => 'all',
    'group' => '0',
    'exposed' => FALSE,
    'expose' => array(
      'operator' => FALSE,
      'label' => '',
    ),
    'id' => 'current',
    'table' => 'spaces',
    'field' => 'current',
    'relationship' => 'none',
  ),
  'type' => array(
    'operator' => 'in',
    'value' => array(
      'book' => 'book',
    ),
    'group' => '0',
    'exposed' => FALSE,
    'expose' => array(
      'operator' => FALSE,
      'label' => '',
    ),
    'id' => 'type',
    'table' => 'node',
    'field' => 'type',
    'relationship' => 'none',
  ),
));
$handler->override_option('access', array(
  'type' => 'none',
));
$handler->override_option('items_per_page', 0);
$handler->override_option('row_plugin', 'node');
$handler->override_option('row_options', array(
  'teaser' => 0,
  'links' => 0,
  'comments' => 0,
));
return $view;
}

/**
 * VIEWS 1 @TODO: upgrade =============================================
 */

/* VIEWS */

function _spaces_core_views_ref_blog2book() {
  $view = new stdClass();
  $view->name = 'ref_blog2book';
  $view->description = 'Provides a list of blog entries that refer to the given book page.';
  $view->access = array();
  $view->view_args_php = '';
  $view->page = FALSE;
  $view->block = TRUE;
  $view->block_title = t('Discussions');
  $view->block_type = 'table';
  $view->nodes_per_block = '50';
  $view->sort = array (
    array (
      'tablename' => 'node',
      'field' => 'created',
      'sortorder' => 'DESC',
      'options' => 'normal',
    ),
  );
  $view->argument = array(
    array(
      'type' => 'content: field_referenced_book_page',
      'argdefault' => '1',
    ),
  );
  $view->field = array (
    array (
      'tablename' => 'node',
      'field' => 'title',
      'label' => t('Title'),
      'handler' => 'views_handler_field_nodelink',
      'options' => 'link',
    ),
    array (
      'tablename' => 'users',
      'field' => 'name',
      'label' => t('Author'),
    ),
    array (
      'tablename' => 'node',
      'field' => 'created',
      'label' => t('Posted'),
      'handler' => 'views_handler_field_date_small',
    ),
  );
  $view->filter = array (
    array (
      'tablename' => 'node',
      'field' => 'type',
      'operator' => 'OR',
      'options' => '',
      'value' => array (
        0 => 'blog',
      ),
    ),
    array (
      'tablename' => 'spaces',
      'field' => 'type',
      'operator' => 'all',
      'options' => '',
      'value' => 'all',
    ),
  );
  $view->requires = array(node, node_comment_statistics, users);
  return $view;
}

function _spaces_core_views_user_posts() {
  $view = new stdClass();
  $view->name = 'spaces_user_posts';
  $view->description = t('Shows updated posts.');
  $view->access = array();
  $view->view_args_php = '';
  $view->page = TRUE;
  $view->page_title = t('Recent Posts');
  $view->page_empty = '<p class="views-empty">'.t('No recent posts found').'</p>';
  $view->page_empty_format = '2';
  $view->page_type = 'table';
  $view->url = 'userposts';
  $view->use_pager = TRUE;
  $view->nodes_per_page = '25';
  $view->block = TRUE;
  $view->block_title = t('Recent Posts');
  $view->block_empty = '<p class="views-empty">'.t('No recent posts found').'</p>';
  $view->block_empty_format = '1';
  $view->block_type = 'table';
  $view->nodes_per_block = '10';
  $view->block_more = TRUE;
  $view->sort = array (
    array (
      'tablename' => 'node_comment_statistics',
      'field' => 'last_comment_timestamp',
      'sortorder' => 'DESC',
      'options' => 'normal',
    ),
  );
  $view->argument = array(
    array (
      'type' => 'uidtouch',
      'argdefault' => '7',
      'title' => "%1's Posts",
    ),
  );
  $view->field = array (
    array (
      'tablename' => 'node',
      'field' => 'title',
      'label' => 'Title',
      'handler' => 'views_handler_field_nodelink_with_mark',
      'options' => 'link',
    ),
    array (
      'tablename' => 'node',
      'field' => 'type',
      'label' => 'Type',
    ),
    array (
      'tablename' => 'node_comment_statistics',
      'field' => 'comment_count',
      'label' => 'Replies',
      'handler' => 'views_handler_comments',
    ),
    array (
      'tablename' => 'node_comment_statistics',
      'field' => 'last_comment_timestamp',
      'label' => 'Last Post',
      'handler' => 'views_handler_field_since',
      'options' => 1,
    ),
  );
  // @TODO: this needs to die -- this view should probably not be here
  // to begin with.
  $exclude = array('shout');
  if (module_exists('og')) {
    $exclude = array_merge(og_get_types('group'), $exclude);
  }
  $view->filter = array (
    array (
      'tablename' => 'node',
      'field' => 'status',
      'operator' => '=',
      'options' => '',
      'value' => '1',
    ),
    array (
      'tablename' => 'node',
      'field' => 'type',
      'operator' => 'NOR',
      'options' => '',
      'value' => $exclude,
    ),
    array (
      'tablename' => 'spaces',
      'field' => 'type',
      'operator' => 'all',
      'options' => '',
      'value' => 'all',
    ),
  );
  $view->requires = array(node_comment_statistics, node);
  return $view;
}

function _spaces_core_views_changes() {
  $view = new stdClass();
  $view->name = 'spaces_changes';
  $view->description = t('Displays a list of recently modified nodes.');
  $view->access = array();
  $view->view_args_php = '';
  $view->page = TRUE;
  $view->page_title = t('Recent Changes');
  $view->page_type = 'table';
  $view->url = 'changes';
  $view->use_pager = TRUE;
  $view->nodes_per_page = '25';
  $view->block = TRUE;
  $view->block_title = t('Recent Changes');
  $view->block_empty = "<p class='views-empty'>" . t('No recent changes.') . "</p>";
  $view->block_empty_format = '1';
  $view->block_type = 'spaces_datetitle';
  $view->nodes_per_block = '5';
  $view->argument = array();
  $view->sort = array (
    array (
      'tablename' => 'node',
      'field' => 'changed',
      'sortorder' => 'DESC',
      'options' => 'normal',
    ),
  );
  $view->field = array (
    array (
      'tablename' => 'og_node_data',
      'field' => 'title',
      'label' => 'Group',
      'handler' => 'spaces_views_handler_crayon_name',
      'options' => 'og',
    ),
    array (
      'tablename' => 'node',
      'field' => 'title',
      'label' => t('Title'),
      'handler' => 'views_handler_field_nodelink',
      'options' => 'link',
    ),
    array (
      'tablename' => 'node',
      'field' => 'changed',
      'label' => t('Changed'),
      'handler' => 'views_handler_field_since',
      'options' => 1,
    ),
    array (
      'tablename' => 'node',
      'field' => 'type',
      'label' => t('Type'),
    ),
    array (
      'tablename' => 'users',
      'field' => 'name',
      'label' => t('Author'),
    ),
  );
  if (variable_get('spaces_calendar_feed_itemtype', '')) {
    $excluded = array('shout', variable_get('spaces_calendar_feed_itemtype', ''));
  }
  else {
    $excluded = array('shout');
  }
  // @TODO: this needs to die -- this view should probably not be here
  // to begin with.
  if (module_exists('og')) {
    $excluded = array_merge(og_get_types('group'), $excluded);
  }
  
  $view->filter = array (
    array (
      'tablename' => 'node',
      'field' => 'type',
      'operator' => 'NOR',
      'options' => '',
      'value' => $excluded,
    ),
    array (
      'tablename' => 'og_uid_node',
      'field' => 'currentuid',
      'operator' => '=',
      'options' => '',
      'value' => '***CURRENT_USER***',
    ),
    array (
      'tablename' => 'spaces',
      'field' => 'type',
      'operator' => 'active',
      'options' => '',
      'value' => 'all',
    ),
    array (
      'tablename' => 'node',
      'field' => 'changed',
      'operator' => '>',
      'options' => -1*SPACES_ARCHIVE_TIMESTAMP,
      'value' => 'now',
    ),
  );
  $view->exposed_filter = array();
  $view->requires = array('node', 'users', 'og_node_data', 'og_uid_node');
  return $view;
}

function _spaces_core_views_comments() {
  $view = new stdClass();
  $view->name = 'spaces_comments';
  $view->description = t('Displays a listing of recent comments');
  $view->access = array();
  $view->view_args_php = '';
  $view->page = TRUE;
  $view->page_title = t('Recent Comments');
  $view->page_empty = '<p class="views-empty">'. t('No recent comments found.') .'</p>';
  $view->page_empty_format = '2';
  $view->page_type = 'table';
  $view->url = 'comments';
  $view->use_pager = TRUE;
  $view->nodes_per_page = '25';
  $view->block = TRUE;
  $view->block_title = t('Recent Comments');
  $view->block_empty = "<p class='views-empty'>". t('No recent comments.') ."</p>";
  $view->block_empty_format = '1';
  $view->block_type = 'spaces_datetitle';
  $view->nodes_per_block = '5';
  $view->sort = array (
    array (
      'tablename' => 'node_comment_statistics',
      'field' => 'last_comment_timestamp',
      'sortorder' => 'DESC',
      'options' => 'normal',
    ),
  );
  $view->argument = array();
  $view->field = array (
    array (
      'tablename' => 'og_node_data',
      'field' => 'title',
      'label' => 'Group',
      'handler' => 'spaces_views_handler_crayon_name',
      'options' => 'og',
    ),
    array (
      'tablename' => 'comments',
      'field' => 'subject',
      'label' => t('Comment'),
      'handler' => 'views_handler_field_commentlink',
      'options' => 'link',
    ),
    array (
      'tablename' => 'comments',
      'field' => 'name',
      'label' => t('By'),
    ),
    array (
      'tablename' => 'node',
      'field' => 'title',
      'label' => t('On Post'),
      'handler' => 'views_handler_field_nodelink',
      'options' => 'nolink',
    ),
    array (
      'tablename' => 'node',
      'field' => 'type',
      'label' => t('Type'),
    ),
    array (
      'tablename' => 'node_comment_statistics',
      'field' => 'last_comment_timestamp',
      'label' => t('Date'),
      'handler' => 'views_handler_field_date_small',
    ),
  );
  $view->filter = array (
    array (
      'tablename' => 'node',
      'field' => 'status',
      'operator' => '=',
      'options' => '',
      'value' => '1',
    ),
    array (
      'tablename' => 'node_comment_statistics',
      'field' => 'comment_count',
      'operator' => '>',
      'options' => '',
      'value' => '0',
    ),
    array (
      'tablename' => 'og_uid_node',
      'field' => 'currentuid',
      'operator' => '=',
      'options' => '',
      'value' => '***CURRENT_USER***',
    ),
    array (
      'tablename' => 'spaces',
      'field' => 'type',
      'operator' => 'active',
      'options' => '',
      'value' => 'all',
    ),
    array (
      'tablename' => 'node_comment_statistics',
      'field' => 'last_comment_timestamp',
      'operator' => '>',
      'options' => -1*SPACES_ARCHIVE_TIMESTAMP,
      'value' => 'now',
    ),    
  );
  $view->exposed_filter = array();
  $view->requires = array(node_comment_statistics, comments, node, og_node_data, og_uid_node);
  return $view;
}

function _spaces_core_views_taxonomy() {
  $view = new stdClass();
  $view->name = 'spaces_taxonomy';
  $view->description = t('Spaces taxonomy override.');
  $view->access = $view->field = $view->exposed_filter = array ();
  $view->page = TRUE;
  $view->page_empty = '<p>'. t('No entries found.') . '</p>';
  $view->page_empty_format = '2';
  $view->page_type = 'table';
  $view->use_pager = TRUE;
  $view->nodes_per_page = '20';
  $view->field = array(
    array (
      'tablename' => 'node',
      'field' => 'title',
      'label' => 'Title',
      'handler' => 'views_handler_field_nodelink',
      'sortable' => '1',
      'options' => 'link',
    ),
    array (
      'tablename' => 'node',
      'field' => 'created',
      'label' => 'Date',
      'handler' => 'views_handler_field_date_small',
      'sortable' => '1',
      'defaultsort' => 'DESC',
    ),
    array (
      'tablename' => 'node',
      'field' => 'type',
      'label' => 'Type',
      'sortable' => '1',
    ),
  );
  $view->sort = array ();
  $view->argument = array (
    array (
      'type' => 'taxid',
      'argdefault' => '1',
      'options' => '0',
      'wildcard' => '',
      'wildcard_substitution' => '',
    ),
  );
  $view->filter = array (
    array (
      'tablename' => 'node',
      'field' => 'status',
      'operator' => '=',
      'options' => '',
      'value' => '1',
    ),
    array (
      'tablename' => 'spaces',
      'field' => 'type',
      'operator' => 'active',
      'options' => '',
      'value' => 'all',
    ),
  );
  $view->requires = array(node);
  return $view;
}

function _spaces_core_views_tags() {
  $view = new stdClass();
  $view->name = 'spaces_tags';
  $view->description = '';
  $view->access = array();
  $view->page = FALSE;
  $view->block = TRUE;
  $view->block_title = t('Tags');
  $view->block_empty = '<p>'. t('No tags found.') .'</p>';
  $view->block_empty_format = '1';
  $view->block_type = 'tagadelic';
  $view->nodes_per_block = '20';
  $view->sort = array ();
  $view->filter = array (
    array (
      'tablename' => 'node',
      'field' => 'status',
      'operator' => '=',
      'options' => '',
      'value' => '1',
    ),
    array (
      'tablename' => 'term_data',
      'field' => 'vid',
      'operator' => 'AND',
      'options' => '',
      'value' => array (
        0 => '11',
      ),
    ),
    array (
      'tablename' => 'spaces',
      'field' => 'type',
      'operator' => 'active',
      'options' => '',
      'value' => 'all',
    ),
  );
  $view->argument = array ();
  $view->field = array (
    array (
      'tablename' => 'term_node',
      'field' => 'name',
      'label' => '',
      'options' => 'link',
    ),
  );
  $view->exposed_filter = array();
  $view->requires = array(term_node, node, term_data);
  return $view;
}
